/* #################################################################### */
/* ##								     ##	*/									
/* ##	                PROGETTO "HOTEL ONLINE "          	     ##	*/									
/* ##		       Gennaio 2001 (Giugno 2001)		     ##	*/									
/* ##								     ##	*/									
/* ##			SERVER - CLIENT ALBERGO	        	     ##	*/									
/* ##								     ##	*/									
/* ##								     ##	*/									
/* ##	   Laura Esposito(565379) & Vincenza Zermo(563237)	     ##	*/									
/* ##								     ##	*/									
/* #################################################################### */



#include "lib.h"

#define INPUT 0


int codAlb;
char nome[NOME]; 
int posti;






// ===================================  Procedura Menu  ===================================================

/*Viene stampato a video il menu dell'albergo per poter far interagire l'utente con il server-client  */



void Menu(int NumPren,char stato) {
  fprintf(stderr,"\n");
  fprintf(stderr,"\n");
  fprintf(stderr,"############################################\n\n");
  fprintf(stderr,"  Informazioni sull'albergo  \n\n");
  fprintf(stderr,"  Albergo: %s\n",nome);
  if ( stato==0x67 ) {
    fprintf(stderr,"  Stato: Chiuso\n");
  } else {
    fprintf(stderr,"  Stato: Aperto\n");
  }
  fprintf(stderr,"  Posti disponibili: %d\n",posti);
  fprintf(stderr,"  Posti Prenotati: %d\n",NumPren);
  fprintf(stderr,"\n");
  fprintf(stderr,"  Comandi da tastiera  \n\n");
  fprintf(stderr,"   A: Aprire l'albergo\n");
  fprintf(stderr,"   C: Chiudere l'albergo\n");
  fprintf(stderr,"   P: Posti prenotati\n");
  fprintf(stderr,"   Z: Prenotazioni azzerate\n");
  fprintf(stderr,"\n");
  fprintf(stderr,"############################################\n");
  fprintf(stderr,"\n");
  fprintf(stderr,"\n");
}





// ===================================  Procedura Gestisci  ===================================================

/* Viene gestito il lato Server dell'albergo, creando la socket passiva in attesa di richieste di connessione */
/* da parte del turista;inoltre vengono gestite le richieste che l'utente invia da tastiera, come il cambio */
/* di stato dell'albergo e l'azzeramento del  contatore delle prenotazioni */



int Gestisci(int sock_Alb,int sock_Ente) {
 
  fd_set rfds;
  fd_set afds;
  int nfds;
  int err; 
  int sock_Tur;
  int lung_Tur;
  struct sockaddr_in ind_tur;
  char In[MES];
  char Out[MES];
  char aus[MES]; 
  int NumPren; 
  int PostiPren; 
  char stato; /* A=Aperto(ascii A=65), C=Chiuso(ascii C=67) */
  

  /* inizializzo lo stato(CHIUSO di default),il numero di posti prenotati e i file descriptor aperti */
  NumPren = 0;
  stato = 0x67;
  nfds = FOPEN_MAX; 
  FD_ZERO(&afds);
  FD_SET(sock_Ente, &afds); 
  FD_SET(sock_Alb, &afds);
  
  /* viene settato lo standard input da tastiera nella struttura */ 
  FD_SET(INPUT,&afds); 
  
  
  /* inizio del ciclo di attesa del lato server*/
  while(1) {
    bcopy ((char*) &afds, (char*) &rfds, sizeof(rfds));
    
    fprintf(stderr,"\nIn attesa di input...\n\n");
    if (select(nfds, &rfds, (fd_set*) 0, (fd_set*) 0, (struct timeval*) 0) < 0) {
      fprintf(stderr,"Errore: Select() %s\n", sys_errlist[errno]);
      return(-1);
    }
    
    if (FD_ISSET(sock_Alb, &rfds)) {
      lung_Tur = sizeof(ind_tur);
      sock_Tur = accept(sock_Alb, (struct sockaddr*) &ind_tur, &lung_Tur);
      if (sock_Tur <0) {
	fprintf(stderr,"Errore: Accept() %s\n", sys_errlist[errno]);
	return(-2);
      }
      fprintf(stderr,"Connessione di un nuovo turista sulla socket: %d\n", sock_Tur);

      /* manda la ack di connessione avvenuta */
      sprintf(&Out,"ACK");  
      Send(sock_Tur,&Out);

      /* viene letto il messaggio di prenotazione del turista */
      bzero(In,sizeof(In));
      if (read(sock_Tur,&In,sizeof(In))<=0) {  
	sprintf(&Out,"NACK_GS3");  
	Send(sock_Tur,&Out);
	close(sock_Tur);
	fprintf(stderr,"Errore: Read() %s!!\n", sys_errlist[errno]);
	return -3;
      }
      bzero(aus,sizeof(aus)); 
      estrai(&In,&aus);
     
      /* controlla che il messaggio ricevuto sia una prenotazione, altrimenti esce */
      if ( strcmp(aus,"PR") ) {
	sprintf(&Out,"NACK_GS4");  
	Send(sock_Tur,&Out);
	close(sock_Tur);
	fprintf(stderr,"Codice del messaggio errato!!\n");
	return -4;
      }

      /* controlla lo stato dell'albergo: se e' aperto accetta la prenotazione altrimenti la rifiuta */
      if ( stato==0x65 ) {
	bzero(aus,sizeof(aus)); 
	estrai(&In,&aus);
	if ( !strcmp(&aus,"") ) {
	  sprintf(&Out,"NACK_GS5");  
	  Send(sock_Tur,&Out);
	  close(sock_Tur);
	  fprintf(stderr,"Stringa dei numero posti vuota\n");
	  return -5;
	}
	PostiPren = atoi(&aus);
	fprintf(stderr,"Richiesta di prenotazione di %d posti\n",PostiPren);
	if ( PostiPren<=0 ) {
	  sprintf(&Out,"NACK_GS6");  
	  Send(sock_Tur,&Out);
	  close(sock_Tur);
	  fprintf(stderr,"Numero di posti disponibili errato\n");
	  return -6;
	}

	/* controlla se puo' accettare la prenotazione effettivamenti */
	if ( NumPren+PostiPren>posti ) {
	  /* se i posti posti disponibili sono insufficienti viene spedito un NACK */
	  sprintf(&Out,"NACK");  
	  Send(sock_Tur,&Out);
	  fprintf(stderr,"L'albergo e' al COMPLETO!!!\n");
	} else {
	  /* se i posti sono disponibili vengono aggiornate le prenotazioni spedito un ACK */
	  NumPren+=PostiPren;
	  sprintf(&Out,"ACK");  
	  Send(sock_Tur,&Out);
	  fprintf(stderr,"Prenotazione ACCETTATA!!\n",PostiPren);
	}

      } else {
	/* l'albergo e' chiuso e viene spedito un NACK */
	sprintf(&Out,"NACK");  
	Send(sock_Tur,&Out);
	fprintf(stderr,"L'albergo e' CHIUSO!!!\n");
      }

      /* chiude la socket dedicata al turista */
      close(sock_Tur);
      fprintf(stderr,"Connessione con il turista chiusa...\n");
      
    } else 
      /* vengono gestite le richieste da tastiera sullo stdin */
       if (FD_ISSET(INPUT, &rfds)) {
         bzero(In,sizeof(In));
      if ( read(INPUT,&In,sizeof(In))<=0) {
	fprintf(stderr,"Errore: Read() %s!!\n", sys_errlist[errno]);
	return -7;
      }
      
      bzero(aus,sizeof(aus));
      estrai(&In,&aus);
      
      /* gestione della richiesta di apertura dell'albergo */
      if ( !strcmp(&aus,"A") || !strcmp(&aus,"a") ) {
	
	fprintf(stderr,"##########################################\n");
	if ( stato==0x65 ) {
	  fprintf(stderr,"ALBERGO GIA' APERTO!!\n");
	} else {
	  stato=0x65;
	  fprintf(stderr,"ALBERGO APERTO!!\n");
          sprintf(&Out,"AP_%d",codAlb);  
	  Send(sock_Ente,&Out);
	  
	  /* Attesa ACK da ente */
	  bzero(In,sizeof(In));
	  if ( (err=read(sock_Ente,&In,sizeof(In)))<0) {
	    sprintf(&Out,"NACK_GS8");  
	    Send(sock_Ente,&Out);
	    fprintf(stderr,"Errore: Read() %s!!\n", sys_errlist[errno]);
	    return -8;
	  }
	  if ( err==0 ) {
	    fprintf(stderr,"Connessione chiusa dall'ente!!\n");
	    return -9;
	  }

	  /* controlla se l'ente ha accettato l'apertura */
	  bzero(aus,sizeof(aus));
	  estrai(&In,&aus);
	  if ( strcmp(&aus,"ACK") ) {
	    fprintf(stderr,"Apertura dell'albergo errata!!\n");
	    return -10;
	  }
	}
	fprintf(stderr,"#########################################\n");

      /* gestione della richiesta di chiusura dell'albergo */
      
      } else if ( !strcmp(&aus,"C") || !strcmp(&aus,"c") ) {
	
	fprintf(stderr,"#########################################\n");
	if ( stato==0x67 ) {
	  fprintf(stderr,"ALBERGO GIA' CHIUSO!!\n");
	} else {
	  stato=0x67;
	  fprintf(stderr,"ALBERGO CHIUSO!!\n");
          sprintf(&Out,"CH_%d",codAlb);  
	  Send(sock_Ente,&Out);
	
	  bzero(In,sizeof(In));
	  if (read(sock_Ente,&In,sizeof(In))<0) {
	    sprintf(&Out,"NACK_GS11");  
	    Send(sock_Ente,&Out);
	    fprintf(stderr,"Errore: Read() %s!!\n", sys_errlist[errno]);
	    return -11;
	  }
	  if ( err==0 ) {
	    fprintf(stderr,"Connessione Chiusa dall'Ente!!\n");
	    return -12;
	  }

	  /* controlla se l'ente ha accettato la chiusura */
	  bzero(aus,sizeof(aus));
	  estrai(&In,&aus);
	  if ( strcmp(&aus,"ACK") ) {
	    fprintf(stderr,"Chiusura dell'albergo errata!!\n");
	    return -13;
	  }
	}
	fprintf(stderr,"###########################################\n");

       /* gestione della richiesta di visualizzazione dei posti prenotati */
      
      } else if ( !strcmp(&aus,"P") || !strcmp(&aus,"p") ) {
	fprintf(stderr,"\n");
	fprintf(stderr,"###########################################\n");
	fprintf(stderr,"Posti Prenotati %d su %d disponibili\n",PostiPren,posti);
	fprintf(stderr,"###########################################\n");
	fprintf(stderr,"\n");

       /* gestione della richiesta azzeramento delle prenotazioni */
      
      } else if ( !strcmp(&aus,"Z") || !strcmp(&aus,"z") ) {
	fprintf(stderr,"\n");
	fprintf(stderr,"###########################################\n");
	fprintf(stderr,"Prenotazioni Azzerate!!!\n");
	fprintf(stderr,"###########################################\n");
	fprintf(stderr,"\n");
	PostiPren=0;

        /* gestione della richiesta di visulaizzaione del menu dei comandi */
      
      } else if ( !strcmp(&aus,"M") || !strcmp(&aus,"m") ) {
	Menu(NumPren,stato);

        /* gestione della richiesta di un comando inesistente */
      
      } else {
	fprintf(stderr,"\n");
	fprintf(stderr,"##########################################\n");
	fprintf(stderr,"Opzione errata!!!\n");
	fprintf(stderr,"##########################################\n");
	fprintf(stderr,"\n");
      }
    } else if (FD_ISSET(sock_Ente, &rfds)) {

      /* Controllo di chiusura della socket da parte dell'ente */
      bzero(In,sizeof(In));
      if ( (err=read(sock_Ente,&In,sizeof(In)))<0) {
	fprintf(stderr,"Errore:Read() %s!!\n", sys_errlist[errno]);
	return -14;
      }
      if ( err==0 ) {
	fprintf(stderr,"Connessione Chiusa dall'Ente!!\n");
	return -15;
      }

    }
  }
}






// ===================================  Procedura socketEnte  ===================================================

/* Procedura che crea la socket attiva connessa all'ente */


int socketEnte(char *IP_Ente,int porta_Ente,int porta_Alb) {

  int conv;
  int err;
  int sock_Ente;
  struct sockaddr_in ind_ente;
  char In[MES];
  char Out[MES];
  char aus[MES]; 
  
  
  if ( (sock_Ente = socket(AF_INET,SOCK_STREAM,0))<0 ) {
    fprintf(stderr,"Errore: Socket() %s!!\n", sys_errlist[errno]);
    return -1;      
  }
  
  fprintf(stderr,"Richiesta di connessione al Server Ente Turistico...\n");
  fprintf(stderr,"IP ente: %s\nPorta ente: %u\n",IP_Ente,porta_Ente);

  ind_ente.sin_family = AF_INET;
  ind_ente.sin_port = htons(porta_Ente);
  conv = inet_aton(IP_Ente,&(ind_ente.sin_addr));
 
  if ( connect(sock_Ente,&ind_ente,sizeof ind_ente)<0 ) {
    fprintf(stderr,"Errore: Connect() %s!!\n", sys_errlist[errno]);
    return -2;      
  }
  bzero(In,sizeof In);
  if ( (err=read(sock_Ente,In,sizeof In))<0 ) {
    fprintf(stderr,"Errore: Read() %s!!\n", sys_errlist[errno]);
    return -3;      
  }
  if ( err==0 ) {
    fprintf(stderr,"Connessione chiusa dall'Ente!!\n");
    return -4;      
  } 
 
  bzero(aus,sizeof aus);
  estrai(&In,&aus);
  if ( strcmp(&aus,"ID") ) {
    fprintf(stderr,"Codice del messaggio errato!!\n");
    return -5;
  }

  bzero(aus,sizeof aus);
  estrai(&In,&aus);
  
  
  if ( !strcmp (&aus,"") ) {
    fprintf(stderr,"Stringa del codice albergo vuota\n");
    return -6;
  }
  codAlb=atoi(aus);
  fprintf(stderr,"Codice Albergo: %d\n",codAlb);
  if ( codAlb==0 ) {
    fprintf(stderr,"Codice albergo errato\n");
    return -7;
  }

  /* notifica all'ente che e' un albergo */
  bzero(Out,sizeof Out);
  sprintf(&Out,"ID_A_%d_%s_%d_%d",codAlb,nome,posti,porta_Alb);
  Send(sock_Ente,&Out);

  /* attende ACK dall'ente */
  bzero(In,sizeof In);
  if ( (err=read(sock_Ente,In,sizeof In))<0 ) {
    fprintf(stderr,"Errore: Read() %s!!\n", sys_errlist[errno]);
    return -7;      
  }
  if ( err==0 ) {
    fprintf(stderr,"Connessione chiusa dall'Ente!!\n");
    return -8;      
  } 
  
  bzero(aus,sizeof aus);
  estrai(&In,&aus);
  if ( strcmp(&aus,"ACK") ) {
    fprintf(stderr,"Errore nella registrazione all'ente!!\n");
    return -9;
  }

  /* ritorna il numero di ID del socket */
  return sock_Ente;
}








// ===================================  Procedura serverSock  ===================================================

/* Procedura che crea un socket per accettare le connessioni dei turisti. */ 
/* Restituisce il descrittore del socket creato. */


int serverSock(int porta_Alb)
 {
  int sock_Alb;
  struct sockaddr_in ind_alb;
  
  
  sock_Alb = socket(PF_INET, SOCK_STREAM, 0);
  if(sock_Alb<0) {
    printf("Errore: Socket() %s\n",sys_errlist[errno]);
    return(-1);
  }

  
  ind_alb.sin_family = AF_INET;
  ind_alb.sin_port = htons(porta_Alb);
  ind_alb.sin_addr.s_addr = htonl(INADDR_ANY);

  
  if(bind(sock_Alb, (struct sockaddr *)&ind_alb, sizeof(ind_alb)) == -1) {
    printf("Errore: Bind() %s\n",sys_errlist[errno]);
    return(-2);
  }

  printf("       [Socket %d <==> porta %d]\n", sock_Alb, porta_Alb);

  if(listen(sock_Alb, 10) == -1) {
    printf("Errore: Listen() %s\n",sys_errlist[errno]);
    return(-3);
  }

  printf("\nServer Albergo in esecuzione...\n");
  
  return sock_Alb;
}




// ===================================  Procedura NomePosti_Alb  ===================================================
/* Procedura nella quale sono memorizzati i dati degli alberghi che possono connettersi con i relativi */
/* dati sui posti prenotabili */
/* Vengono inizializzati la sequenza casuale di scelta dell'albergo */


void NomePosti_Alb(void) {

  int num;
  char benvenuto[1024]="\n    BENVENUTO nel Server-Client Albergo ";
      
  srand((unsigned int)time(NULL));
  num = 1+(int)(5.0*rand()/(RAND_MAX+1.0));


  bzero(&nome,sizeof nome);
  if ( num==1 ) 
   { strcpy((char *)&nome,"Lucy");
     posti = 500;
    } else if ( num==2 )
            { strcpy((char *)&nome,"Charlie");
              posti = 1000;
            } else if ( num==3 ) 
	            { strcpy((char *)&nome,"Snoopy");
                      posti = 250;
                    } else if ( num==4 ) 
		            { strcpy((char *)&nome,"Woodstock");
                              posti = 500;
                            } else { strcpy((char *)&nome,"Linus");
                                     posti = 100;
                                   }
  printf("%s %s\n", benvenuto, nome);
  fprintf(stderr,"          [Posti disponibili: %d]\n",posti);
  return;
}





// ===================================  M A I N  ===================================================




int main(int argc,char *argv[]) 
{
  int sock_Ente;
  int sock_Alb;
  char IP_Ente[IND_IP];
  int porta_Ente;
  int porta_Alb;
  


  if (argc!= 4) {
    Errore("USO: >./albergo <IP ente> [porta ente] [porta albergo]",-1,NULL);
  }

  bzero(IP_Ente,sizeof IP_Ente);
  strcpy(&IP_Ente,argv[1]);
  porta_Ente = atoi(argv[2]);
  porta_Alb = atoi(argv[3]);

  NomePosti_Alb();

  /* creazione della socket attiva che gestice la comunicazione con il turista */
  if ( (sock_Alb = serverSock(porta_Alb) )<0 ) {
    exit(-2);
  }

  /* creazione della socket passiva per la connessione all'ente */
  if ( (sock_Ente = socketEnte(&IP_Ente,porta_Ente,porta_Alb) )<0 ) {
    close(sock_Alb);
    exit(-3);
  }

  if ( Gestisci(sock_Alb,sock_Ente)<0 ) {
    close(sock_Alb);
    close(sock_Ente);
    exit(-4);
  }

  close(sock_Alb);
  close(sock_Ente);
  exit(0);
}
