/* #################################################################### */
/* ##								     ##	*/									
/* ##	                PROGETTO "HOTEL ONLINE "          	     ##	*/									
/* ##		       Gennaio 2001 (Giugno 2001)		     ##	*/									
/* ##								     ##	*/									
/* ##			   CLIENT TURISTA	                     ##	*/									
/* ##								     ##	*/									
/* ##								     ##	*/									
/* ##	   Laura Esposito(565379) & Vincenza Zermo(563237)	     ##	*/									
/* ##								     ##	*/									
/* #################################################################### */




#include "lib.h"



//============================== Procedura MAIN ================================================================


/* Viene gestito il client turista in un unica procedura, quindi viene gestita sia la connessione */
/* con l'ente che la connessione diretta con il server-client albergo per poter effettuare le prenotazioni */ 


int main(int argc,char *argv[])
{
  unsigned short int sock;
  struct sockaddr_in ind_ente;
  char In[MES];
  char Out[MES];
  struct albergo *head;
  struct albergo *hotel;
  struct albergo *punta;
  char nome[NOME]; 
  char appoggio[MES];
  char IP_hotel[IND_IP]; 
  char IP_ente[IND_IP]; 
  int porta_Alb;  
  int porta_Ente; 
  int nho,ris,n,N_Alberghi,as,posti; 


  if (argc!=3) {
    Errore("USO: >./turista <IP ente> [porta ente]", -1, NULL);
  
  }

  bzero(IP_ente,sizeof IP_ente);
  strcpy(&IP_ente,argv[1]);
  porta_Ente=(unsigned short int)strtoul(argv[2],NULL,10);

  srand((unsigned int)time(NULL));

  while (1) {
 /* inizia la richiesta di connessione al server */
    if ( (sock=socket(AF_INET,SOCK_STREAM,0))<0 ){
      fprintf(stderr,"Errore: Socket()\n");
      exit(2);
     }
    
    printf("\nRichiesta di connessione all'ente...\n");
    printf("IP ente: %s\nPorta ente: %u\n\n",IP_ente,porta_Ente);

    /* memorizzo i dati della connessione in una struttura di tipo sockaddr_in */
    ind_ente.sin_family=AF_INET;
    ind_ente.sin_port=htons(porta_Ente);
    ris=inet_aton(&IP_ente,&(ind_ente.sin_addr));
    
    if ( connect(sock,&ind_ente,sizeof ind_ente)<0 ) {
      fprintf(stderr,"Errore: Connect() %s!!\n", sys_errlist[errno]);
      exit(3);      
    }
    /*legge il numero identificativo dall'ente */
    bzero(In,sizeof In );
    if ( (ris=read(sock,In,sizeof In))<0 ){
      fprintf(stderr,"Errore: Read()\n");
      exit(4);
     }
    
    if ( ris==0 ) {
      fprintf(stderr,"Connessione chiusa dall'Ente!!\n");
      exit(5);
     }
    
    bzero(&appoggio,sizeof appoggio);
    estrai(&In,&appoggio);
    if ( strcmp(&appoggio,"ID") ){ 
      fprintf(stderr,"Codice del messaggio errato!!\n");
      exit(6);    
     }

    /* notifica all'ente che tipo di client se e' collegato*/
    bzero(Out,sizeof Out);
    sprintf(&Out,"ID_T\n");
    Send(sock,&Out);
    
    /*attenede ACK dall'ente*/
    bzero(In,sizeof In);
    if ( (ris=read(sock,In,sizeof In))<0 ){ 
      fprintf(stderr,"Errore: Read()\n");
      exit(7);
     }
    
    if ( ris==0 ){ 
     fprintf(stderr,"Connessione chiusa dall'Ente!!\n");
     exit(8);
    } 
    
    bzero(&appoggio,sizeof appoggio);
    estrai(&In,&appoggio);
    if ( strcmp(&appoggio,"ACK") ) {
      fprintf(stderr,"Sequenza di connessione errata!!\n");
      exit(9);
    }

    /* Richiede la lista degli alberghi aperti all'ente*/
    bzero(Out,sizeof Out);
    sprintf(&Out,"LA\n",posti);
    Send(sock,&Out);

    N_Alberghi=0;
    punta=NULL;
    head=NULL;
    /* ciclo di attesa dei messaggi con i dati degli alberghi aperti */
    while ( 1 ) {
      bzero(In,sizeof In);
      if ( (ris=read(sock,In,sizeof In))<0 ) {
	fprintf(stderr,"Errore: Read()\n");
	exit(10);
      }
      if ( ris==0 ) {
	fprintf(stderr,"Connessione chiusa dall'Ente!!\n");
	exit(11);

      }
      fprintf(stderr,"Ricevuto Messaggio...\n");

      bzero(&appoggio,sizeof appoggio);
      estrai(&In,&appoggio);

      while ( strlen(&appoggio)>0 && strcmp(&appoggio,"ACK") ) {
        if ( strcmp(&appoggio,"AL") ) {
	  fprintf(stderr,"Codice del messaggio errato!!\n");
	  exit(12);
	}
	
	/* memorizza il nome dell'albergo*/
	bzero(nome,sizeof nome);
	estrai(&In,&nome);
	fprintf(stderr,"Albergo: %s\n",nome);
	if (!strcmp (&nome,"") ) {
	  fprintf(stderr,"Stringa del nome dell'albergo vuota\n");
	  exit(13);

	}
	
	/* memorizza il numero di posti disponibili dell'albergo e ne controlla il valore */
	bzero(appoggio,sizeof appoggio);
	estrai(&In,&appoggio);
	if ( !strcmp (&appoggio,"") ) {
	  fprintf(stderr,"Stringa del numero di posti vuota\n");
	  exit(14);
	}
	nho=atoi(appoggio);
	fprintf(stderr,"Posti disponibili: %d\n",nho);
	if ( nho==0 ) {
	 fprintf(stderr,"Numero di posti errato\n");
	  exit(15); 
	}
	
	/* memorizza l'indirizzo IP dell'albergo e controlla che non sia vuoto */
	bzero(IP_hotel,sizeof IP_hotel);
	estrai(&In,&IP_hotel);
	fprintf(stderr,"IP albergo: %s\n",IP_hotel);
	if ( !strcmp (&IP_hotel,"") ) {
	  fprintf(stderr,"Indirizzo IP dell'albergo errato!!\n");
	  exit(16);
	}
	
	/* memorizza la porta di connessione dell'albergo e controlla il valore */
	bzero(appoggio,sizeof appoggio);
	estrai(&In,&appoggio);
	if ( !strcmp (&appoggio,"") ) {
	  fprintf(stderr,"Stringa della porta dell'albergo errata\n");
	  exit(17);
	}
	porta_Alb=atoi(appoggio);
	fprintf(stderr,"Porta albergo: %d\n",porta_Alb);
	if ( porta_Alb==0 ) {
	  fprintf(stderr,"Porta dell'albergo errata\n");
	  exit(18); 
	}
	
	/* viene creata la nuova struttura albergo riempita con i nuovi ricevuti dalla richiesta*/
	hotel=(struct albergo *)malloc(sizeof(struct albergo));
	if ( hotel==NULL ) {
	  fprintf(stderr,"Errore: Malloc()\n");
	  exit(19);
	}
	hotel->codice=++N_Alberghi;
	strcpy((char *)&(hotel->nome),&nome);
	hotel->posti=nho;
	hotel->stato=(char)"A";
	strcpy((char *)&(hotel->indIP),(char *)IP_hotel);
	hotel->porta=porta_Alb;
	hotel->next=NULL;
	
	/* inserisce l'albergo nella lista inizialmente in testa e poi in coda */
	if ( head==NULL ) {
	  head=hotel;
	} else {
	  punta->next=hotel;
	}
	punta=hotel;
	fprintf(stderr,"Inserito il nuovo albergo in lista!!\n");
	
	bzero(&appoggio,sizeof appoggio);
	estrai(&In,&appoggio);

      }

      if ( !strcmp(&appoggio,"ACK") ) {
	break;
      }

    }

    /* chiude la connessione con l'ente */
    close(sock);

    /* si prosegue nel ciclo se il numero degli alberghi ricevuti e' maggiore di 0*/
    if ( N_Alberghi>0 ) {

      /* viene scelto l'albergo a cui connettersi */
      as=1+(int) (1.0*N_Alberghi*rand()/(RAND_MAX+1.0));
      fprintf(stderr,"Albergo scelto per le prenotazioni: %d\n",as);

      /* viene ricercato l'albergo nella lista */
      hotel=head;
      while (hotel->codice<as && hotel!=NULL) {
	hotel=hotel->next;
      }

      /* copio le informazioni riguardanti l'albergo prescelto in variabili d'appoggio */
      strcpy((char *)(IP_hotel),(char *)&(hotel->indIP));
      porta_Alb=hotel->porta;
      nho=hotel->posti;

      /*viene eliminata la lista degli alberghi */
      eliminaLAlberghi();
     
      /* viene creata la socket di connessione con l'albergo scelto */
      if ( (sock=socket(AF_INET,SOCK_STREAM,0))<0 ) {
	fprintf(stderr,"Errore: Socket()\n");
	exit(20);

      }
      printf("\nRichiesta di connessione all'albergo...\n");
      printf("IP: %s\nPorta:%u\n\n",IP_hotel,porta_Alb);

      /* memorizzo i dati della connessione in una struttura di tipo sockaddr_in */
      ind_ente.sin_family=AF_INET;
      ind_ente.sin_port=htons(porta_Alb);
      inet_aton(&IP_hotel,&(ind_ente.sin_addr));
      
      /* viene aperta la connessione con l'albergo */
      if ( connect(sock,&ind_ente,sizeof ind_ente)<0 ) {
	fprintf(stderr,"Errore: Connetc()\n");
	exit(21);
      }
      
      /* attende ACK dall'albergo */
      bzero(In,sizeof In);
      if ( (ris=read(sock,In,sizeof In))<0 ) {
	fprintf(stderr,"Errore: Read()\n");
	exit(22);
      }
      if ( ris==0 ) {
	fprintf(stderr,"Connessione chiusa dall'Ente!!\n");
	exit(23);

      }
      fprintf(stderr,"Ricevuto Messaggio...\n");

      bzero(appoggio,sizeof appoggio);
      estrai(&In,&appoggio);
      if ( strcmp(&appoggio,"ACK") ) {
	fprintf(stderr,"Messaggio errato!!!\n");
	exit(24);
      }

      /* vengono scelti il numero di posti da prenotare e ne controlla il valore */
      posti=1+(int) (1.0*Ndisponibili*random()/(RAND_MAX+1));
      if ( posti<0 ) {
	posti=-posti;
      } else if ( posti==0 ) {
	posti++;
      }
      if ( posti>nho ) {
	posti=nho;
      }

      /*viene spedita la richiesta di prenotazione e il numero di posti*/
      bzero(Out,sizeof Out);
      sprintf(&Out,"PR_%d\n",posti);
      Send(sock,&Out);

      bzero(In,sizeof In);
      if ( (ris=read(sock,In,sizeof In))<0) {
	fprintf(stderr,"Errore: Read()\n");
	exit(25);
      }
      if ( ris==0 ) {
	fprintf(stderr,"Connessione chiusa dall'Ente!!\n");
	exit(26);
      }

      /* viene controllato l'esito della prenotazione */
      bzero(appoggio,sizeof appoggio);
      estrai(&In,&appoggio);
      if ( !strcmp(&appoggio,"ACK")) {
	/* la prenotazione viene accettata*/
	fprintf(stderr,"Confermata Prenotazione per %d posti\n",posti);
	fprintf(stderr,"Prossima richiesta tra 4 secondi...\n");
      } else {
	/*la prenotazione viene rifiutata*/
	fprintf(stderr,"Prenotazione Rifiutata\n");
	fprintf(stderr,"Prossima richiesta tra 4 secondi...\n");
      }

      /* viene chiusa la connessione con l'albergo */
      close(sock);
    }

    /* mette a dormire il processo per 4 secondi */
    sleep(4);
  }

  return 0;
}


